package io.zipcoder;

import java.util.HashMap;
import java.util.Map;
import java.util.Stack;

public class ParenChecker {


    public boolean matchingCharacters(char char1, char char2) {

        if (char1 == '(' && char2 == ')') {

            return true;
        } else if (char1 == '{' && char2 == '}') {

            return true;
        } else if (char1 == '[' && char2 == ']') {

            return true;
        } else if (char1 == '<' && char2 == '>'){

            return true;
        } else {
            return false;
        }

    }


    public boolean balancedCharacters(String input, char pair1, char pair2) {
        Stack<Character> stack = new Stack<Character>();
        char[] array = input.toCharArray();


        for (char c : array) {

            if (c == pair1) {

                stack.push(c);
            }
             else if (c == pair2) {
                 if(stack.empty()) {
                     return false;
                 }

                 else if (!matchingCharacters(stack.pop(), c)) {
                     return false;
                 }

            }

        }
        if (stack.empty()) {
            return true;
        } else {
            return false;
        }
    }

    public boolean quotationMarks(String input) {
       // Stack<Character> stack = new Stack<Character>();
        char[] array = input.toCharArray();
        boolean paired = false;
        int dblQuote = 0;
        int singleQuote = 0;
        for (char c : array) {
            if(c == '\"') {
                dblQuote++;
            } else if (c == '\''){
                singleQuote++;
            }

        }
        if (dblQuote % 2 == 0 && singleQuote % 2 == 0)
            paired = true;


        return paired;

        }



    public boolean completeCheck(String input) {




        boolean parenth = balancedCharacters(input, '(', ')');
        boolean square = balancedCharacters(input, '[', ']');
        boolean curly = balancedCharacters(input, '{', '}');
        boolean angle = balancedCharacters(input, '<', '>');
        boolean quotes = quotationMarks(input);

        if(parenth == true && square == true && curly ==true && angle == true && quotes == true) {
            return true;
        }
        else {
            return false;
        }


    }



}
